LeetCode OJ - Two Sum

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9

Output: index1=1, index2=2


my answer:

public class Solution {
    public int[] twoSum(int[] nums, int target) {

    	int[] res = new int[2];

    	for(int x=0;x<nums.length;x++){
    		for(int y=x+1;y<nums.length;y++){
    			
    			if (nums[x] + nums[y] == target){
    				res[0] = x+1; 
    				res[1] = y+1;
 					return res;
    			}   			
    		}
    	}      
        return null;
    }
}
Runtime:  41 ms

参考: http://blog.sina.com.cn/s/blog_7bee572b0101ux4q.html

改进如下:

public class Solution_1 {
    public int[] twoSum(int[] numbers, int target) {
        int[] res = new int[2];
        HashMap<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i = 0; i < numbers.length; i++){
            map.put(numbers[i], i);
        }
        for(int i = 0; i < numbers.length; i++){
            int gap = target - numbers[i];
            if(map.get(gap)!= null &&map.get(gap)!= i){
                res[0] = i+1;
                res[1] = map.get(gap) + 1;
                break;
            }
        }
    return res;
    }
}

Runtime: 8  ms


总结:暴力搜索,时间复杂度为O(n*n),很简单,但是会出现超时错误。

    利用HashMap,存储数组中的值和Index,由于HashMap中查询键值对的开销是固定的,因此在性能上可以得到很大的提升。

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值